# Table of contents
```@contents
Pages = ["tutorial.md", "world2.md", "world3.md", "source.md"]
Depth = 6
```

# WorldDynamics.jl

An open-source framework written in Julia for world dynamics modeling and simulation.

## The World Dynamics Project

The World Dynamics project aims to provide a modern framework to investigate models of global dynamics focused on sustainable development based on current software engineering and scientific machine learning techniques. Our group is developing a Julia library to allow scientists to easily use and adapt different world models, from Forrester's World2 to Meadows et al.'s World3 to recent proposals. By enabling an open, interdisciplinary, and consistent comparative approach to scientific model development, our goal is to supply high-quality information to global policy making on environmental and economic issues.

# Index of functions

```@index
Pages   = ["source.md"]
Modules = [WorldDynamics]
Order   = [:function]
```
