# Source code documentation

## Contents

```@contents
Pages = ["source.md"]
Depth = 3
```

## WorldDynamics constants
```@autodocs
Modules = [WorldDynamics]
Order   = [:constant]
```

## WorldDynamics functions

### Functions in `functions.jl`

This functions correspond to `DYNAMO` functions used in the World3 model.

```@autodocs
Modules = [WorldDynamics]
Order   = [:function]
Pages   = ["functions.jl"]
```

### Functions in `plotvariables.jl`

```@autodocs
Modules = [WorldDynamics]
Order   = [:function]
Pages   = ["plotvariables.jl"]
```

### Functions in `solvesystems.jl`

```@autodocs
Modules = [WorldDynamics]
Order   = [:function]
Pages   = ["solvesystems.jl"]
```

## Reproducing World2 figures

### World2 system

```@autodocs
Modules = [WorldDynamics.World2]
Pages   = ["plots.jl"]
```

## Reproducing World3 figures

### Agriculture system

```@autodocs
Modules = [WorldDynamics.World3.Agriculture]
Pages   = ["plots.jl"]
```

### Capital system

```@autodocs
Modules = [WorldDynamics.World3.Capital]
Pages   = ["plots.jl"]
```

### Non-Renewable system

```@autodocs
Modules = [WorldDynamics.World3.NonRenewable]
Pages   = ["plots.jl"]
```

### Pollution system

```@autodocs
Modules = [WorldDynamics.World3.Pollution]
Pages   = ["plots.jl"]
```

### One level population system

```@autodocs
Modules = [WorldDynamics.World3.Pop1]
Pages   = ["plots.jl"]
```

### Four level population system

```@autodocs
Modules = [WorldDynamics.World3.Pop4]
Pages   = ["plots.jl"]
```

### Fifteen level population system

```@autodocs
Modules = [WorldDynamics.World3.Pop15]
Pages   = ["plots.jl"]
```

### World3 system

```@autodocs
Modules = [WorldDynamics.World3]
Pages   = ["plots.jl"]
```
