_inits = Dict{Symbol, Float64}(
    :t0 => 1900,
    :frsn => 0.82, # Line 41.2 Appendix A
    :pop => 1.61e9,
    :ppolx => 1.0,
)

_inits[:sopc] = 1.5e11 / _inits[:pop]
_inits[:hsapc] = interpolate(_inits[:sopc], _tables[:hsapc], _ranges[:hsapc])
_inits[:fpc] = 4e11 / _inits[:pop]
_inits[:lmf] = interpolate(_inits[:fpc] / _params[:sfpc], _tables[:lmf], _ranges[:lmf])
_inits[:lmhs] = interpolate(_inits[:hsapc], _tables[:lmhs1], _ranges[:lmhs1])
_inits[:lmp] = interpolate(_inits[:ppolx], _tables[:lmp], _ranges[:lmp])
_inits[:iopc] = 0.7e11 / _inits[:pop]
_inits[:cmi] = interpolate(_inits[:iopc], _tables[:cmi], _ranges[:cmi])
_inits[:fpu] = interpolate(_inits[:pop], _tables[:fpu], _ranges[:fpu])
_inits[:lmc] = 1 - _inits[:cmi] * _inits[:fpu]
_inits[:le] = _params[:len] * _inits[:lmf] * _inits[:lmhs] * _inits[:lmp] * _inits[:lmc]
_inits[:fm] = interpolate(_inits[:le], _tables[:fm], _ranges[:fm])
_inits[:mtf] = _params[:mtfn] * _inits[:fm]
_inits[:sfsn] = interpolate(_inits[:iopc], _tables[:sfsn], _ranges[:sfsn])
_inits[:dcfs] = _params[:dcfsn] * _inits[:frsn] * _inits[:sfsn]
_inits[:ple] = _inits[:le]
_inits[:cmple] = interpolate(_inits[:ple], _tables[:cmple], _ranges[:cmple])
_inits[:dtf] = _inits[:dcfs] * _inits[:cmple]
_inits[:nfc] = _inits[:mtf] / _inits[:dtf] - 1.0
_inits[:fsafc] = interpolate(_inits[:nfc], _tables[:fsafc], _ranges[:fsafc])
_inits[:fcapc] = _inits[:fsafc] * _inits[:sopc]
_inits[:fcfpc] = _inits[:fcapc]
_inits[:fce] = interpolate(_inits[:fcfpc], _tables[:fce], _ranges[:fce])
_inits[:tf] = min(_inits[:mtf], _inits[:mtf] * (1.0 - _inits[:fce]) + _inits[:dtf] * _inits[:fce])
_inits[:br] = _inits[:tf] * _inits[:pop] * _params[:ffw] / _params[:rlt]
_inits[:cbr] = 1000 * _inits[:br] / _inits[:pop]
